package com.ruoyi.frequency.highendauth.service;

import java.util.List;
import java.util.Map;

import com.ruoyi.controller.req.UpscaleAuthReq;
import com.ruoyi.frequency.highendauth.entity.HighendAuth;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.frequency.highendauth.model.result.HighendAuthCount;
import com.ruoyi.response.ResponseData;
import com.ruoyi.vo.UserVo;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 高端认证Service接口
 *
 * @author liwenlong
 * @date 2023-10-20
 */
public interface HighendAuthService extends IService<HighendAuth>
{
    /**
     * 查询高端认证
     *
     * @param id 高端认证主键
     * @return 高端认证
     */
    public HighendAuth selectHighendAuthById(Long id);

    /**
     * 查询高端认证列表
     *
     * @param highendAuth 高端认证
     * @return 高端认证集合
     */
    public List<HighendAuth> selectHighendAuthList(HighendAuth highendAuth);

    HighendAuthCount statistics(HighendAuth highendAuth);

    /**
     * 新增高端认证
     *
     * @param highendAuth 高端认证
     * @return 结果
     */
    public int insertHighendAuth(HighendAuth highendAuth);

    /**
     * 修改高端认证
     *
     * @param highendAuth 高端认证
     * @return 结果
     */
    public int updateHighendAuth(HighendAuth highendAuth);

    /**
     * 批量删除高端认证
     *
     * @param ids 需要删除的高端认证主键集合
     * @return 结果
     */
    public int deleteHighendAuthByIds(Long[] ids);

    /**
     * 删除高端认证信息
     *
     * @param id 高端认证主键
     * @return 结果
     */
    public int deleteHighendAuthById(Long id);

    /**
     * 上传企业微信二维码
     * @param highendAuth
     * @return
     */
    int uploadCode(HighendAuth highendAuth);


    /**
     * 高端认证
     * @param req
     * @param userVo
     * @return
     */
    ResponseData highendAuth(UpscaleAuthReq req, UserVo userVo);


    /**
     * 支付宝回调
     * @param request
     * @param response
     * @return
     */
    ResponseData highendAuthAliNotify(HttpServletRequest request, HttpServletResponse response);


    /**
     * 微信回调
     * @param request
     * @param response
     * @return
     */
    ResponseData highendAuthWxNotify(HttpServletRequest request, HttpServletResponse response);

    ResponseData highendAuthLakalaNotify(Map<String, String> paramMap);
}
